// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from psdk_interfaces:srv/PerceptionStereoVisionSetup.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__SRV__DETAIL__PERCEPTION_STEREO_VISION_SETUP__STRUCT_HPP_
#define PSDK_INTERFACES__SRV__DETAIL__PERCEPTION_STEREO_VISION_SETUP__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__srv__PerceptionStereoVisionSetup_Request __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__srv__PerceptionStereoVisionSetup_Request __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct PerceptionStereoVisionSetup_Request_
{
  using Type = PerceptionStereoVisionSetup_Request_<ContainerAllocator>;

  explicit PerceptionStereoVisionSetup_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->stereo_cameras_direction = "";
      this->start_stop = false;
    }
  }

  explicit PerceptionStereoVisionSetup_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stereo_cameras_direction(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->stereo_cameras_direction = "";
      this->start_stop = false;
    }
  }

  // field types and members
  using _stereo_cameras_direction_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _stereo_cameras_direction_type stereo_cameras_direction;
  using _start_stop_type =
    bool;
  _start_stop_type start_stop;

  // setters for named parameter idiom
  Type & set__stereo_cameras_direction(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->stereo_cameras_direction = _arg;
    return *this;
  }
  Type & set__start_stop(
    const bool & _arg)
  {
    this->start_stop = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    psdk_interfaces::srv::PerceptionStereoVisionSetup_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::srv::PerceptionStereoVisionSetup_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::srv::PerceptionStereoVisionSetup_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::srv::PerceptionStereoVisionSetup_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::srv::PerceptionStereoVisionSetup_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::srv::PerceptionStereoVisionSetup_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::srv::PerceptionStereoVisionSetup_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::srv::PerceptionStereoVisionSetup_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::srv::PerceptionStereoVisionSetup_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::srv::PerceptionStereoVisionSetup_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__srv__PerceptionStereoVisionSetup_Request
    std::shared_ptr<psdk_interfaces::srv::PerceptionStereoVisionSetup_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__srv__PerceptionStereoVisionSetup_Request
    std::shared_ptr<psdk_interfaces::srv::PerceptionStereoVisionSetup_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PerceptionStereoVisionSetup_Request_ & other) const
  {
    if (this->stereo_cameras_direction != other.stereo_cameras_direction) {
      return false;
    }
    if (this->start_stop != other.start_stop) {
      return false;
    }
    return true;
  }
  bool operator!=(const PerceptionStereoVisionSetup_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PerceptionStereoVisionSetup_Request_

// alias to use template instance with default allocator
using PerceptionStereoVisionSetup_Request =
  psdk_interfaces::srv::PerceptionStereoVisionSetup_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace psdk_interfaces


#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__srv__PerceptionStereoVisionSetup_Response __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__srv__PerceptionStereoVisionSetup_Response __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct PerceptionStereoVisionSetup_Response_
{
  using Type = PerceptionStereoVisionSetup_Response_<ContainerAllocator>;

  explicit PerceptionStereoVisionSetup_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->message = "";
    }
  }

  explicit PerceptionStereoVisionSetup_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : message(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->message = "";
    }
  }

  // field types and members
  using _success_type =
    bool;
  _success_type success;
  using _message_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _message_type message;

  // setters for named parameter idiom
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }
  Type & set__message(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->message = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    psdk_interfaces::srv::PerceptionStereoVisionSetup_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::srv::PerceptionStereoVisionSetup_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::srv::PerceptionStereoVisionSetup_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::srv::PerceptionStereoVisionSetup_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::srv::PerceptionStereoVisionSetup_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::srv::PerceptionStereoVisionSetup_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::srv::PerceptionStereoVisionSetup_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::srv::PerceptionStereoVisionSetup_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::srv::PerceptionStereoVisionSetup_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::srv::PerceptionStereoVisionSetup_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__srv__PerceptionStereoVisionSetup_Response
    std::shared_ptr<psdk_interfaces::srv::PerceptionStereoVisionSetup_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__srv__PerceptionStereoVisionSetup_Response
    std::shared_ptr<psdk_interfaces::srv::PerceptionStereoVisionSetup_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PerceptionStereoVisionSetup_Response_ & other) const
  {
    if (this->success != other.success) {
      return false;
    }
    if (this->message != other.message) {
      return false;
    }
    return true;
  }
  bool operator!=(const PerceptionStereoVisionSetup_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PerceptionStereoVisionSetup_Response_

// alias to use template instance with default allocator
using PerceptionStereoVisionSetup_Response =
  psdk_interfaces::srv::PerceptionStereoVisionSetup_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace psdk_interfaces

namespace psdk_interfaces
{

namespace srv
{

struct PerceptionStereoVisionSetup
{
  using Request = psdk_interfaces::srv::PerceptionStereoVisionSetup_Request;
  using Response = psdk_interfaces::srv::PerceptionStereoVisionSetup_Response;
};

}  // namespace srv

}  // namespace psdk_interfaces

#endif  // PSDK_INTERFACES__SRV__DETAIL__PERCEPTION_STEREO_VISION_SETUP__STRUCT_HPP_
