// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from psdk_interfaces:srv/PerceptionStereoVisionSetup.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__SRV__DETAIL__PERCEPTION_STEREO_VISION_SETUP__TRAITS_HPP_
#define PSDK_INTERFACES__SRV__DETAIL__PERCEPTION_STEREO_VISION_SETUP__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "psdk_interfaces/srv/detail/perception_stereo_vision_setup__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace psdk_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const PerceptionStereoVisionSetup_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: stereo_cameras_direction
  {
    out << "stereo_cameras_direction: ";
    rosidl_generator_traits::value_to_yaml(msg.stereo_cameras_direction, out);
    out << ", ";
  }

  // member: start_stop
  {
    out << "start_stop: ";
    rosidl_generator_traits::value_to_yaml(msg.start_stop, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PerceptionStereoVisionSetup_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: stereo_cameras_direction
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stereo_cameras_direction: ";
    rosidl_generator_traits::value_to_yaml(msg.stereo_cameras_direction, out);
    out << "\n";
  }

  // member: start_stop
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "start_stop: ";
    rosidl_generator_traits::value_to_yaml(msg.start_stop, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PerceptionStereoVisionSetup_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace psdk_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use psdk_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const psdk_interfaces::srv::PerceptionStereoVisionSetup_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  psdk_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use psdk_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const psdk_interfaces::srv::PerceptionStereoVisionSetup_Request & msg)
{
  return psdk_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<psdk_interfaces::srv::PerceptionStereoVisionSetup_Request>()
{
  return "psdk_interfaces::srv::PerceptionStereoVisionSetup_Request";
}

template<>
inline const char * name<psdk_interfaces::srv::PerceptionStereoVisionSetup_Request>()
{
  return "psdk_interfaces/srv/PerceptionStereoVisionSetup_Request";
}

template<>
struct has_fixed_size<psdk_interfaces::srv::PerceptionStereoVisionSetup_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<psdk_interfaces::srv::PerceptionStereoVisionSetup_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<psdk_interfaces::srv::PerceptionStereoVisionSetup_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace psdk_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const PerceptionStereoVisionSetup_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << ", ";
  }

  // member: message
  {
    out << "message: ";
    rosidl_generator_traits::value_to_yaml(msg.message, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PerceptionStereoVisionSetup_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }

  // member: message
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "message: ";
    rosidl_generator_traits::value_to_yaml(msg.message, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PerceptionStereoVisionSetup_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace psdk_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use psdk_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const psdk_interfaces::srv::PerceptionStereoVisionSetup_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  psdk_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use psdk_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const psdk_interfaces::srv::PerceptionStereoVisionSetup_Response & msg)
{
  return psdk_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<psdk_interfaces::srv::PerceptionStereoVisionSetup_Response>()
{
  return "psdk_interfaces::srv::PerceptionStereoVisionSetup_Response";
}

template<>
inline const char * name<psdk_interfaces::srv::PerceptionStereoVisionSetup_Response>()
{
  return "psdk_interfaces/srv/PerceptionStereoVisionSetup_Response";
}

template<>
struct has_fixed_size<psdk_interfaces::srv::PerceptionStereoVisionSetup_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<psdk_interfaces::srv::PerceptionStereoVisionSetup_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<psdk_interfaces::srv::PerceptionStereoVisionSetup_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<psdk_interfaces::srv::PerceptionStereoVisionSetup>()
{
  return "psdk_interfaces::srv::PerceptionStereoVisionSetup";
}

template<>
inline const char * name<psdk_interfaces::srv::PerceptionStereoVisionSetup>()
{
  return "psdk_interfaces/srv/PerceptionStereoVisionSetup";
}

template<>
struct has_fixed_size<psdk_interfaces::srv::PerceptionStereoVisionSetup>
  : std::integral_constant<
    bool,
    has_fixed_size<psdk_interfaces::srv::PerceptionStereoVisionSetup_Request>::value &&
    has_fixed_size<psdk_interfaces::srv::PerceptionStereoVisionSetup_Response>::value
  >
{
};

template<>
struct has_bounded_size<psdk_interfaces::srv::PerceptionStereoVisionSetup>
  : std::integral_constant<
    bool,
    has_bounded_size<psdk_interfaces::srv::PerceptionStereoVisionSetup_Request>::value &&
    has_bounded_size<psdk_interfaces::srv::PerceptionStereoVisionSetup_Response>::value
  >
{
};

template<>
struct is_service<psdk_interfaces::srv::PerceptionStereoVisionSetup>
  : std::true_type
{
};

template<>
struct is_service_request<psdk_interfaces::srv::PerceptionStereoVisionSetup_Request>
  : std::true_type
{
};

template<>
struct is_service_response<psdk_interfaces::srv::PerceptionStereoVisionSetup_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // PSDK_INTERFACES__SRV__DETAIL__PERCEPTION_STEREO_VISION_SETUP__TRAITS_HPP_
